config/routes.rb
Rails.application.routes.draw do

  root to: 'events#index'

  resources :events,       only: [:index, :show, :update]
  resources :meta_events,  only: [:index, :new, :create, :edit, :update]
  resources :room_prices,  only: [:index, :new, :create, :edit, :update] # fixme - update?
  resources :rooms,        only: [:index, :new, :create, :show, :edit, :update]
  resources :bands,        only: [:index, :new, :create, :show, :edit, :update]
  resources :musicians,    only: [:index, :new, :create, :show, :edit, :update]

end

app/models/meta_event.rb
class MetaEvent < ActiveRecord::Base
  has_one :musician
  has_one :room
  has_many :events
  validates :start_dt, :end_dt, :virtual_date_start, :virtual_date_end, :room_id, :musician_id, presence: true

  validate :date_chronology, :time_chronology
  validate :meta_event_limit , :on => [:create]

  before_save :set_virtual_dates

  def save
    begin
      transaction do
        super!
        self.save_events!
        return self
      end
    rescue ActiveRecord::RecordInvalid => invalid
      # do whatever you wish to warn the user, or log something
      self.errors[:base] << "Ha ocurrido un error al guardar."
      return false
    end
  end

  def save_events!
    (self.start_date..self.end_date).each do |date|
      Event.create!(
        start_date: date, 
        end_date: date, 
        start_time: self.start_time, 
        end_time: self.end_time, 
        virtual_date: date,
        room_id: self.room_id
        meta_event: self
      )
    end
  end

  def update
    begin
      transaction do
        super!
        self.update_events!
        return self
      end
    rescue ActiveRecord::RecordInvalid => invalid
      # do whatever you wish to warn the user, or log something
      self.errors[:base] << "Ha ocurrido un error al guardar."
      return false
    end
  end

  def update_events! 
    # self.events
    # (self.start_date..self.end_date).each do |date|
    #   Event.create!(
    #     start_date: date, 
    #     end_date: date, 
    #     start_time: self.start_time, 
    #     end_time: self.end_time, 
    #     virtual_date: date,
    #     room_id: self.room_id
    #     meta_event: self
    #   )
    end
  end

  def date_chronology
    return true if self.start_date < self.end_date
    self.errors[:base] << "Los dias ingresados no son correctos."
    return false
  end

  def time_chronology
    return true if self.start_time < self.end_time
    self.errors[:base] << "Los horarios ingresados no son correctos."
    return false
  end

  def max_timelapse
    return true if ( self.start_date + 1.years =< self.end_date )
    self.errors[:base] << "Los horarios ingresados no son correctos."
    return false
  end

  def week_day
    return true if ( self.start_date.wday == self.end_date.wday )
    self.errors[:base] << "Los horarios ingresados no son correctos."
    return false
  end

  def set_virtual_dates
    require 'active_support/core_ext'
    self.start_date = self.start_dt.to_date
    self.end_date   = self.end_dt.to_date
  end

end

app/controllers/meta_events_controller.rb
class MetaEventsController < ApplicationController
  before_action :set_meta_event, only: [:show, :edit, :update]

  # GET /meta_events
  # GET /meta_events.json
  def index
    @meta_events = MetaEvent.all
  end

  # GET /meta_events/1
  # GET /meta_events/1.json
  def show
  end

  # GET /meta_events/new
  def new
    @meta_event = MetaEvent.new
  end

  # GET /meta_events/1/edit
  def edit
  end

  # POST /meta_events
  # POST /meta_events.json
  def create
    @meta_event = MetaEvent.new(meta_event_params)

    respond_to do |format|
      if @meta_event.save
        format.html { redirect_to @meta_event, notice: 'Meta event was successfully created.' }
        format.json { render :show, status: :created, location: @meta_event }
      else
        format.html { render :new }
        format.json { render json: @meta_event.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /meta_events/1
  # PATCH/PUT /meta_events/1.json
  def update
    respond_to do |format|
      if @meta_event.update(meta_event_params)
        format.html { redirect_to @meta_event, notice: 'Meta event was successfully updated.' }
        format.json { render :show, status: :ok, location: @meta_event }
      else
        format.html { render :edit }
        format.json { render json: @meta_event.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /meta_events/1
  # DELETE /meta_events/1.json
  def destroy
    @meta_event.destroy
    respond_to do |format|
      format.html { redirect_to meta_events_url, notice: 'Meta event was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_meta_event
      @meta_event = MetaEvent.find(params[:id])
      @event = Event.find(params[:event_id]) if params[:event_id]
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def meta_event_params
      params.require(:meta_event).permit(:meta_event_id, :start_dt, :end_dt, :room_id, :musician_id)
    end
end

app/helpers/meta_events_helper.rb
module MetaEventsHelper
end

app/views/meta_events/_form.html.erb
<%= form_for(@meta_event) do |f| %>
  <% if @meta_event.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@meta_event.errors.count, "error") %> prohibited this meta_event from being saved:</h2>

      <ul>
      <% @meta_event.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :meta_event_id %><br>
    <%= f.number_field :meta_event_id %>
  </div>
  <div class="field">
    <%= f.label :start_dt %><br>
    <%= f.datetime_select :start_dt %>
  </div>
  <div class="field">
    <%= f.label :end_dt %><br>
    <%= f.datetime_select :end_dt %>
  </div>
  <div class="field">
    <%= f.label :virtual_date_start %><br>
    <%= f.date_select :virtual_date_start %>
  </div>
  <div class="field">
    <%= f.label :virtual_date_end %><br>
    <%= f.date_select :virtual_date_end %>
  </div>
  <div class="field">
    <%= f.label :room_id %><br>
    <%= f.number_field :room_id %>
  </div>
  <div class="field">
    <%= f.label :musician_id %><br>
    <%= f.number_field :musician_id %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/meta_events/edit.html.erb
<h1>Editing meta_event</h1>

<%= render 'form' %>

<%= link_to 'Show', @meta_event %> |
<%= link_to 'Back', meta_events_path %>

app/views/meta_events/index.html.erb
<script type="text/javascript" >
$(function() {
  virtual_events = <%= raw( @virtual_events ) %>;
  console.log( virtual_events );
});
</script>

<h1>Listing meta_events</h1>

<table>
  <thead>
    <tr>
      <th>Meta event</th>
      <th>Start</th>
      <th>End</th>
      <th>Virtual date start</th>
      <th>Virtual date end</th>
      <th>Room</th>
      <th>Musician</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @meta_events.each do |meta_event| %>
      <tr>
        <td><%= meta_event.meta_event_id %></td>
        <td><%= meta_event.start %></td>
        <td><%= meta_event.end %></td>
        <td><%= meta_event.virtual_date_start %></td>
        <td><%= meta_event.virtual_date_end %></td>
        <td><%= meta_event.room_id %></td>
        <td><%= meta_event.musician_id %></td>
        <td><%= link_to 'Show', meta_event %></td>
        <td><%= link_to 'Edit', edit_meta_event_path(meta_event) %></td>
        <td><%= link_to 'Destroy', meta_event, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Meta event', new_meta_event_path %>

app/views/meta_events/new.html.erb
<h1>New meta_event</h1>

<%= render 'form' %>

<%= link_to 'Back', meta_events_path %>

app/views/meta_events/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Meta event:</strong>
  <%= @meta_event.meta_event_id %>
</p>

<p>
  <strong>Start:</strong>
  <%= @meta_event.start_dt %>
</p>

<p>
  <strong>End:</strong>
  <%= @meta_event.end_dt %>
</p>

<p>
  <strong>Virtual date start:</strong>
  <%= @meta_event.virtual_date_start %>
</p>

<p>
  <strong>Virtual date end:</strong>
  <%= @meta_event.virtual_date_end %>
</p>

<p>
  <strong>Room:</strong>
  <%= @meta_event.room_id %>
</p>

<p>
  <strong>Musician:</strong>
  <%= @meta_event.musician_id %>
</p>

<%= link_to 'Edit', edit_meta_event_path(@meta_event) %> |
<%= link_to 'Back', meta_events_path %>